//
//  XSPEC12  November 2003
//
//
        
#include <XSUser/Global/Global.h>
#include <XSUser/Global/XSGlobal.h>
#include <XSFit/Fit/Fit.h>        
#include <XSFit/Fit/FitMethod.h>        
#include <XSContainer.h>
#include <XSstreams.h>
#include <xsTypes.h>
#include <XSUtil/Parse/XSparse.h>
#include <memory>

int
XSGlobal::xsMethod(ClientData cdata,Tcl_Interp* tclInterp,int objc, Tcl_Obj* CONST  objv[])
{
   using namespace XSContainer;
   string cmd = string(static_cast<char*>(cdata));
   string arg("");
   if (objc == 1 || (arg = Tcl_GetString(objv[1])) == "?")
   {
       printDocs(cmd.c_str(),"?");
   } 
   else
   {
      StringArray inArgs;
      StringArray params;
      IntegerArray iParams; 
      for (int i=1; i<objc; ++i)
      {
         inArgs.push_back(string(Tcl_GetString(objv[i])));
      }
      XSparse::collectParams(inArgs, iParams, params); 
   
      try
      {
         if (iParams.size())
         {
            if (iParams[0] == 0)
            {
               std::auto_ptr<FitMethod> newFitMethod(FitMethod::get(params[0]));
               if (newFitMethod.get())
               {
                  newFitMethod->processMethodString(iParams, params);
                  // This will automatically call fit update and reset
                  // the isStillValid flag if necessary.
                  fit->fitMethod(newFitMethod.release());
               }
               else throw Fit::NoSuchFitMethod(params[0]);
            }
            else 
            {
               fit->fitMethod()->processMethodString(iParams, params);
               bool wasStillValid = fit->isStillValid();
               fit->Update();
               fit->isStillValid(wasStillValid);
            }
            
         }
      }
      catch ( YellowAlert& )
      {
          // should actually write some code in NoSuchFitMethod that lists
          // the options.
          return globalData->autoSave(TCL_ERROR);   
      }
   }
   tcout << std::flush;
   return globalData->autoSave(TCL_OK);
}
